package org.jboss.btison.switchyard.testbed.camel.xslt;

import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.camel.Endpoint;
import org.apache.camel.EndpointInject;
import org.apache.camel.Produce;
import org.apache.camel.ProducerTemplate;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.test.junit4.CamelTestSupport;
import org.junit.Test;

import com.google.common.base.Charsets;
import com.google.common.io.CharStreams;
import com.google.common.io.Closeables;

public class CamelRouteTest extends CamelTestSupport {
    
    private static final String ENDPOINT_SOURCE = "direct:source"; 
    
    @EndpointInject(uri = ENDPOINT_SOURCE)
    protected Endpoint source;
    
    @Produce(uri = ENDPOINT_SOURCE)
    protected ProducerTemplate producer;
    
    @Override
    protected RouteBuilder createRouteBuilder() throws Exception {
        CamelServiceRoute route = new CamelServiceRoute();
        route.setSourceUri(ENDPOINT_SOURCE);
        return route;
    }
    
    @Test
    public void testRoute() throws Exception {
        
        InputStream is = Thread.currentThread().getContextClassLoader().getResourceAsStream("test.xml");
        String content = CharStreams.toString(new InputStreamReader(is, Charsets.UTF_8));
        Closeables.closeQuietly(is);
       
        producer.sendBody("direct:source",content);
        
        
    }

}
